<?php

require_once 'inc/common.inc.php';
require_once 'inc/functions.inc.php';

$now = date(U);

if ( $_POST['do'] == "edit" ) {
	$form_submit = true;

	$result = $db->query("
		SELECT streamid, start, due
		FROM stream
		WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
		;","Get stream information to change");

	$stream = sqlite_fetch_array($result, SQLITE_ASSOC);

	if ( $now < $stream[start] )
		$stream[start] = $_POST['start'];
	else
		$stream[start] = date("Y-m-d H:i", $stream[start]);
		
	$new_stream = make_stamp(trim($stream['start']), trim($_POST['due']), true);

	if ($new_stream) {
		$result = $db->query("
			SELECT streamid as id, start, due FROM stream
			;","Check overlap streams");

		# calc if there is overlap
		$overlap = false;
		while ($row = sqlite_fetch_array($result, SQLITE_ASSOC)) {
			if ( !($new_stream[start] < $row[start] && $new_stream[due] < $row[start]
					|| $new_stream[start] > $row[due] && $new_stream[due] > $row[due])
					&& $row[id] != $_GET[id]) {
				$overlap = true;
				$form_submit = false;
				$form_error = "Error: Stream overlaps stream {$row[id]}.";
			}
		}
	} else {
		$form_submit = false;
		$form_error = "Error: Invalid input to edit stream &#39;{$_GET[id]}&#39;.";
	}

	if ($form_submit && $new_stream[due] < $now) {
		$form_submit = false;
		$form_error = "Error: End must be in the future of stream &#39;{$_GET[id]}&#39;.";
	}

	if ($form_submit) {
		$result = $db->query("
			UPDATE stream
			SET
				start={$new_stream[start]},
				due={$new_stream[due]}
			WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
			;","Edit stream &#39;{$_GET[id]}&#39;.");
	}
}

echo <<<EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
	<title>Stream Planner - Edit</title>
	<link rel="stylesheet" type="text/css" href="layout/style.css" />
	<link rel="Shortcut Icon" type="image/png" href="layout/favicon.png" />
</head>
<body>

<h1><a href="">Stream Planner</a></h1>

<p><img src="layout/back.png" alt="" /> <a href="index.php">Back</a></p>

<h2><img src="layout/edit-22.png" alt="" /> Edit</h2>

EOT;

if (isset($form_error))
	echo "<p style=\"color: red;\">{$form_error}</p>";

$result = $db->query("
	SELECT streamid, start, running, due, finished
	FROM stream
	WHERE streamid='" . sqlite_escape_string($_GET[id]) . "'
	;","Get stream to edit");

if (sqlite_num_rows($result) != 1) {
	echo "<p style=\"color: red;\">No stream found matching id &#39;{$_GET[id]}&#39;</p>";
} else {

	$stream = sqlite_fetch_array($result);
	
	if ($stream[running] != 'false')
		$stream[show][running] = '<img src="layout/play.png" alt="yes" />';
	else
		if ( $now > $stream[start] && $now < $stream[due] )
			$stream[show][running] = '<img src="layout/warning.png" alt="no" />';
		else
			$stream[show][running] = 'no';
	
	if ($stream[finished] != 'false')
		$stream[show][finished] = '<img src="layout/ok.png" alt="yes" />';
	else
		$stream[show][finished] = 'no';
	
	$stream[show][start] = date("Y-m-d H:i", $stream[start]);
	$stream[show][due] = date("Y-m-d H:i", $stream[due]);
	
	echo <<<EOT
<form action="" method="post">
<table>
<tr>
	<th>streamid:</th>
	<td>
		<input name="do" type="hidden" value="edit" />
		{$_GET['id']}
	</td>
</tr>
<tr>
	<th>running:</th>
	<td>{$stream[show][running]}</td>
</tr>
<tr>
	<th>finished:</th>
	<td>{$stream[show][finished]}</td>
</tr>
<tr>
	<th>start:</th>
	<td>

EOT;

	if ( $now > $stream[start] && $now < $stream[due] || $stream[running] != 'false' || $now > $stream[due] )
		echo "\t\t" . $stream[show][start] . "\n";
	else
		echo "\t\t<input class=\"text\" name=\"start\" type=\"text\" value=\"{$stream[show][start]}\" />\n";
	
	echo <<<EOT
	</td>
</tr>
<tr>
	<th>end:</th>
	<td>

EOT;

	if ( $now > $stream[due] )
		echo $stream[show][due];
	else
		echo "\t\t<input class=\"text\" name=\"due\" type=\"text\" value=\"{$stream[show][due]}\" />\n";
	
	echo <<<EOT
	</td>
</tr>

EOT;

	if ( $now <= $stream[due] )
		echo <<<EOT
<tr>
	<th></th>
	<td><input class="button" type="submit" value="Change" /></td>
</tr>

EOT;

	echo <<<EOT
</table>
</form>

EOT;
}

show_footer();

echo <<<EOT
</body>
</html>

EOT;
?>
