<?php

require_once 'inc/common.inc.php';
require_once 'inc/functions.inc.php';

$now = date(U);
$display_now = date('Y-m-d H:i:s');

if ( $_POST['do'] == "new" ) {
	$form_submit = true;

	$new_stream = make_stamp(trim($_POST['start']), trim($_POST['due']));

	if ($new_stream) {

		$result = $db->query("
			SELECT streamid as id, start, due FROM stream
			;","Check overlap streams");

		# calc if there is overlap
		$overlap = false;
		while ($row = sqlite_fetch_array($result, SQLITE_ASSOC)) {
			if ( !($new_stream[start] < $row[start] && $new_stream[due] < $row[start]
					|| $new_stream[start] > $row[due] && $new_stream[due] > $row[due]) ) {
				$overlap = true;
				$form_submit = false;
				$form_error = "Error: New stream overlaps stream {$row[id]}.";
			}
		}
	} else {
		$form_submit = false;
		$form_error = "Error: Invalid input to plan a new stream.";
	}

	if ($form_submit) {
		$result = $db->query("
			INSERT INTO stream
				(start, due)
			VALUES
				({$new_stream[start]}, {$new_stream[due]})
			;","Plan new stream");

		$reload = '<meta http-equiv="refresh" content="1" />';
	}
}

echo <<<EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
	<title>Stream Planner</title>
	<link rel="stylesheet" type="text/css" href="layout/style.css" />
	<link rel="Shortcut Icon" type="image/png" href="layout/favicon.png" />
	{$reload}
</head>
<body>

<h1><a href="">Stream Planner</a></h1>
<p class="small">Now: {$display_now}</p>

EOT;

$result = $db->query("
	SELECT streamid
	FROM stream
	WHERE start < $now
	AND due > $now
	;","Get running streams");

if (sqlite_num_rows($result) > 0) {
	echo <<<EOT
<h2><img src="layout/running.png" alt="" /> Running</h2>
<table>

EOT;

	show_stream_th();
	while ($row = sqlite_fetch_array($result, SQLITE_ASSOC)) {
		show_stream($row[streamid], "running");
	}

echo <<<EOT
</table>

EOT;
}

$result = $db->query("
	SELECT streamid
	FROM stream
	WHERE start > $now
	AND running = 'false'
	AND finished = 'false'
	ORDER BY start ASC
	;","Get planned streams");

if (sqlite_num_rows($result) > 0) {
	echo <<<EOT
<h2><img src="layout/planned.png" alt="" /> Planned</h2>
<table>

EOT;

	show_stream_th();
	while ($row = sqlite_fetch_array($result, SQLITE_ASSOC)) {
		show_stream($row[streamid], "planned");
	}

echo <<<EOT
</table>

EOT;
}

echo <<<EOT
<h2><img src="layout/new.png" alt="" /> New</h2>

EOT;

if (isset($form_error))
	echo "<p style=\"color: red;\">{$form_error}</p>";

$ymdhm = "yyyy-mm-dd hh:mm";
echo <<<EOT
<form action="" method="post">
<table>
<tr>
	<th>start:</th>
	<td>
		<input name="do" type="hidden" value="new" />
		<input class="text" name="start" type="text" value="{$ymdhm}" onfocus="if(this.value=='{$ymdhm}')this.value='';else this.select()" />
	</td>
</tr>
<tr>
	<th>end:</th>
	<td><input class="text" name="due" type="text" value="{$ymdhm}" onfocus="if(this.value=='{$ymdhm}')this.value='';else this.select()" /></td>
</tr>
<tr>
	<th></th>
	<td><input class="button" type="submit" value="Plan" /></td>
</tr>
</table>
</form>

EOT;

$result = $db->query("
	SELECT streamid
	FROM stream
	WHERE due < $now
	OR finished = 'true'
	ORDER BY due DESC
	;","Get finished streams");

if (sqlite_num_rows($result) > 0) {
	echo <<<EOT
<h2><img src="layout/history.png" alt="" /> History</h2>
<table>

EOT;

	show_stream_th();
	while ($row = sqlite_fetch_array($result, SQLITE_ASSOC)) {
		show_stream($row[streamid], "history");
	}

echo <<<EOT
</table>

EOT;
}

show_footer();

echo <<<EOT
</body>
</html>

EOT;
?>
